

% DO02 - OCTAL RELAY MODULE 1.0.0


% Class DO02
classdef DO02 < Device

   % Public static Constants
   properties (Constant)

      % Channels
      CHANNELS = 8;

   end


   % Public Member Methods
   methods

      % Constructor
      function this = DO02(address)

         % Initialize
         this = this@Device(address);

      end


      % Write
      function write(this, varargin)

         % Check Parameters
         if nargin == 2

            % Set Channel List and State List
            channel = 1 : this.CHANNELS;
            state = repmat(varargin{1}, 1, this.CHANNELS);

         elseif nargin == 3

            % Set Channel and State
            channel = varargin{1};
            state = varargin{2};

            % Check Parameter
            if isscalar(state)

               % Set State List
               state = repmat(state, 1, numel(channel));

            end

         else

            % Error Handler
            this.error_(this.ERROR_PARAMETER_);

         end

         % Write
         code = calllib('device', 'do02_write', this.address_, channel, numel(channel), state, numel(state));

         % Error Handler
         this.error_(code);

      end

   end

end
