

% VO01 - OCTAL VOLTAGE OUTPUT DEVICE 1.1.0


% Class VO01
classdef VO01 < Device

   % Public static Constants
   properties (Constant)
       
      % Channels
      CHANNELS = 8;
      
   end
   
   
   % Public Member Methods
   methods

      % Constructor
      function this = VO01(address)

         % Initialize
         this = this@Device(address);

      end


      % Control
      function control(this, varargin)

         % Check Parameters
         if nargin == 2

            % Set Channel List and Voltage List
            channel = 1 : this.CHANNELS;
            voltage = repmat(varargin{1}, 1, this.CHANNELS);

         elseif nargin == 3

            % Set Channel and Voltage
            channel = varargin{1};
            voltage = varargin{2};

            % Check Parameter
            if isscalar(voltage)

               % Set Voltage List
               voltage = repmat(voltage, 1, numel(channel));

            end

         else

            % Error Handler
            this.error_(this.ERROR_PARAMETER_);

         end

         % Control
         code = calllib('device', 'vo01_control', this.address_, channel, numel(channel), voltage, numel(voltage));

         % Error Handler
         this.error_(code);

      end

   end

end
